## timidity41-c1b7c55.zip

=== CMakeLists.txt ===

cmake_minimum_required(VERSION 3.9)

project(timidity41)

set(TIM41_USE_AVX2 FALSE CACHE BOOL "Enable use of Intel AVX2 enhanced instructions")

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_DEBUG "${CMAKE_BINARY_DIR}/Debug/bin")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELEASE "${CMAKE_BINARY_DIR}/Release/bin")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO "${CMAKE_BINARY_DIR}/RelWithDebInfo/bin")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_MINSIZEREL "${CMAKE_BINARY_DIR}/MinSizeRel/bin")

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_DEBUG "${CMAKE_BINARY_DIR}/Debug/lib")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELEASE "${CMAKE_BINARY_DIR}/Release/lib")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELWITHDEBINFO "${CMAKE_BINARY_DIR}/RelWithDebInfo/lib")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_MINSIZEREL "${CMAKE_BINARY_DIR}/MinSizeRel/lib")

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_DEBUG "${CMAKE_BINARY_DIR}/Debug/lib")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELEASE "${CMAKE_BINARY_DIR}/Release/lib")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELWITHDEBINFO "${CMAKE_BINARY_DIR}/RelWithDebInfo/lib")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_MINSIZEREL "${CMAKE_BINARY_DIR}/MinSizeRel/lib")

find_package(Git)

if("${Git_FOUND}" AND EXISTS "${CMAKE_SOURCE_DIR}/.git")
    add_custom_target(
        UpdateTim41Version
        COMMAND "${CMAKE_COMMAND}"
            -DGIT_EXECUTABLE="${GIT_EXECUTABLE}"
            -DINFILE="${CMAKE_CURRENT_SOURCE_DIR}/version.h.in"
            -DOUTFILE="${CMAKE_CURRENT_BINARY_DIR}/version.h"
            -P "${CMAKE_CURRENT_SOURCE_DIR}/WriteVersion.cmake"
        WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
        COMMENT "Updating version info..."
    )
else()
    set(tim41VersionStr "current")
    set(tim41Version4Comma "41,0,0,0")
    configure_file(version.h.in version.h)
endif()

include_directories("${CMAKE_CURRENT_BINARY_DIR}")

add_definitions(
# TiMidity++ common
    -DRETSIGTYPE=int
    -DSTDC_HEADERS
    -DHAVE_GETCWD
    -DHAVE_POPEN
    -DHAVE_SIGNAL
    -DHAVE_SNPRINTF
    -DHAVE_STRDUP
    -DHAVE_STRERROR
    -DHAVE_STRNCASECMP
    -DHAVE_STRSTR
    -DHAVE_VPRINTF
    -DHAVE_VSNPRINTF
    -DHAVE_ERRNO_H
    -DHAVE_LIMITS_H
    -DHAVE_MALLOC_H
    -DHAVE_STDLIB_H
    -DHAVE_SYS_TYPES_H
    -DHAVE_FCNTL_H
    -DHAVE_LIBVORBIS
    -DHAVE_LIBGOGO
    -DHAVE_MMSYSTEM_H
    -DENABLE_SHERRY
    -DENABLE_THREAD
    -DSUPPORT_SOUNDSPEC
    -DANOTHER_MAIN
    -D__W32__
    -D__W32READDIR__
	-DUSE_TWSYN_BRIDGE
    -DENABLE_SFZ

# TiMidity++ audio
    -DAU_W32
    -DAU_WASAPI
    -DAU_WDMKS
    -DAU_OPUS
    -DAU_OPUS_DLL
    -DAU_SPEEX
    -DAU_LAME
    -DAU_GOGO
    -DAU_GOGO_DLL
    -DAU_VORBIS
    -DAU_VORBIS_DLL
    -DVORBIS_DLL_INCLUDE_VORBISENC
    -DAU_FLAC
    -DAU_FLAC_DLL
    -DAU_OGGFLAC
    -DAU_PORTAUDIO
    -DAU_PORTAUDIO_DLL
    -DPORTAUDIO_V19
    -DPORTAUDIO_V19_6
    -DVST_LOADER_ENABLE
    -DVSTWRAP_EXT
    -DAU_NPIPE
    -DAU_LIST
    -DAU_WRITE_MIDI
    -DAU_MODMIDI
    -DAU_VOLUME_CALC
    -DAU_BENCHMARK

# network
    -DWINSOCK
    -DHAVE_SOCKET
    -DSUPPORT_SOCKET

# pdcurses
    -DPDC_DLL_BUILD

# Windows
    -DWIN32_LEAN_AND_MEAN
    -DWINVER=0x0A00
    -D_WIN32_WINNT=0x0A00

# MSVCRT
    -D_CRT_SECURE_NO_WARNINGS
)

if(TIM41_USE_AVX2)
    add_definitions(-DUSE_AVX2)
else()
    add_definitions(-DUSE_SSE42)
endif()

if(MSVC)
    add_compile_options(/W4 /Zi /GS /fp:fast /permissive- /MP /Qspectre)
    
    if(TIM41_USE_AVX2)
        add_compile_options(/arch:AVX2)
    endif()
    
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc /std:c++17")

    set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /GL /guard:cf")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /GL /guard:cf")

    set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /DEBUG:FASTLINK")
    set(CMAKE_SHARED_LINKER_FLAGS_DEBUG "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} /DEBUG:FASTLINK")
    set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /OPT:REF /OPT:ICF /LTCG:incremental /DEBUG:FULL /GUARD:CF")
    set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /OPT:REF /OPT:ICF /LTCG:incremental /DEBUG:FULL /GUARD:CF")
    set(CMAKE_STATIC_LINKER_FLAGS_RELEASE "${CMAKE_STATIC_LINKER_FLAGS_RELEASE} /LTCG:incremental")
    set(CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO} /OPT:REF /DEBUG:FASTLINK")
    set(CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO} /OPT:REF /DEBUG:FASTLINK")

    add_definitions(
        -DSTDOUT_FILENO=1
    )
else()
    add_compile_options(-Wall -Wextra -ffast-math)

    if(TIM41_USE_AVX2)
        add_compile_options(-mavx2)
    else()
        add_compile_options(-msse4.2)
    endif()

	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17")
    set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -flto")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -flto")
    set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} -s")
    set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} -s")
    set(CMAKE_RC_FLAGS "-O coff")
endif()

function(DisableMSManifest targetName)
    if(MSVC)
        get_property(linkFlags TARGET ${targetName} PROPERTY LINK_FLAGS)
        set_target_properties(${targetName} PROPERTIES LINK_FLAGS "${linkFlags} /MANIFEST:NO")
    endif()
endfunction()

include_directories(
    "."
    FLAC/include
    interface
    lame/DLL
    lame/include
    libarc
    libunimod
    ogg/include
    opus/include
    pdcurses
    portaudio/include
    timidity
	twsyn_bridge
    utils
    vorbis/include
)

add_subdirectory(FLAC)
add_subdirectory(lame)
add_subdirectory(ogg)
add_subdirectory(opus)
add_subdirectory(pdcurses)
add_subdirectory(portaudio)
add_subdirectory(speex)
add_subdirectory(vorbis)

add_subdirectory(cfgforsf)
add_subdirectory(interface)
add_subdirectory(libarc)
add_subdirectory(libunimod)
add_subdirectory(sf_view_gui)
add_subdirectory(timidity)
add_subdirectory(twsyn_bridge)
add_subdirectory(utils)

=== FLAC/CMakeLists.txt ===

add_definitions(
    -DFLAC_API_EXPORTS
    -DFLAC__HAS_X86INTRIN
    -DFLAC__HAS_OGG

    -DPACKAGE_VERSION="1.3.2"
)

if(MINGW)
    add_definitions(
        -DHAVE_FSEEKO
        -DHAVE_LROUND
    )
endif()

include_directories(src)

add_library(
    libFLAC SHARED

    include/FLAC/all.h
    include/FLAC/assert.h
    include/FLAC/callback.h
    include/FLAC/export.h
    include/FLAC/format.h
    include/FLAC/metadata.h
    include/FLAC/ordinals.h
    include/FLAC/stream_decoder.h
    include/FLAC/stream_encoder.h

    src/private/all.h
    src/private/bitmath.h
    src/private/bitreader.h
    src/private/bitwriter.h
    src/private/cpu.h
    src/private/crc.h
    src/private/fixed.h
    src/private/float.h
    src/private/format.h
    src/private/lpc.h
    src/private/macros.h
    src/private/md5.h
    src/private/memory.h
    src/private/metadata.h
    src/private/ogg_decoder_aspect.h
    src/private/ogg_encoder_aspect.h
    src/private/ogg_helper.h
    src/private/ogg_mapping.h
    src/private/stream_encoder.h
    src/private/stream_encoder_framing.h
    src/private/window.h

    src/share/alloc.h
    src/share/compat.h
    src/share/endswap.h
    src/share/getopt.h
    src/share/grabbag.h
    src/share/macros.h
    src/share/private.h
    src/share/replaygain_analysis.h
    src/share/replaygain_synthesis.h
    src/share/safe_str.h
    src/share/utf8.h
    src/share/windows_unicode_filenames.h
    src/share/win_utf8_io.h

    src/bitmath.c
    src/bitreader.c
    src/bitwriter.c
    src/cpu.c
    src/crc.c
    src/fixed.c
    src/fixed_intrin_sse2.c
    src/fixed_intrin_ssse3.c
    src/float.c
    src/format.c
    src/lpc.c
    src/lpc_intrin_avx2.c
    src/lpc_intrin_sse.c
    src/lpc_intrin_sse2.c
    src/lpc_intrin_sse41.c
    src/md5.c
    src/memory.c
    src/metadata_iterators.c
    src/metadata_object.c
    src/ogg_decoder_aspect.c
    src/ogg_encoder_aspect.c
    src/ogg_helper.c
    src/ogg_mapping.c
    src/stream_decoder.c
    src/stream_encoder.c
    src/stream_encoder_framing.c
    src/stream_encoder_intrin_avx2.c
    src/stream_encoder_intrin_sse2.c
    src/stream_encoder_intrin_ssse3.c
    src/window.c
    src/windows_unicode_filenames.c
)

set_target_properties(libFLAC PROPERTIES PREFIX "")
target_link_libraries(libFLAC libogg)

=== cfgforsf/CMakeLists.txt ===

add_definitions(-DCFG_FOR_SF)

add_executable(
    cfgforsf

    ../interface/dumb_c.c
    ../timidity/common.c
    ../timidity/controls.c
    ../timidity/envelope.c
    ../timidity/filter.c
    ../timidity/freq.c
    ../timidity/instrum.c
    ../timidity/int_synth.c
    ../timidity/mt19937ar.c
    ../timidity/myini.c
    ../timidity/quantity.c
    ../timidity/resample.c
    ../timidity/sbkconv.c
    ../timidity/sffile.c
    ../timidity/sfitem.c
    ../timidity/sfz.cpp
    ../timidity/smplfile.c
    ../timidity/sndfont.c
    ../timidity/tables.c
    ../timidity/version.c

    ../timidity/common.h
    ../timidity/controls.h
    ../timidity/envelope.h
    ../timidity/filter.h
    ../timidity/freq.h
    ../timidity/instrum.h
    ../timidity/int_synth.h
    ../timidity/mt19937ar.h
    ../timidity/myini.h
    ../timidity/output.h
    ../timidity/playmidi.h
    ../timidity/quantity.h
    ../timidity/readmidi.h
    ../timidity/resample.h
    ../timidity/sffile.h
    ../timidity/sfitem.h
    ../timidity/sflayer.h
    ../timidity/sfz.h
    ../timidity/tables.h
    ../timidity/timidity.h
    ../timidity/wrd.h
    ../utils/mblock.h
    ../utils/nkflib.h
    ../utils/strtab.h
    ../utils/support.h

    $<TARGET_OBJECTS:libarc>
    $<TARGET_OBJECTS:utils>
)

add_dependencies(cfgforsf UpdateTim41Version)
target_link_libraries(cfgforsf ws2_32)

=== interface/CMakeLists.txt ===

set(
    INTERFACE_COMMON_SOURCES

    ncurs_c.c
    rtsyn_common.c
    vt100.c
    vt100_c.c
    VTPrsTbl.c
    w32g_soundspec.c
    wrdt_dumb.c
    wrdt_tty.c

    gtk_h.h
    mac_c.h
    mac_mag.h
    mac_wrdwindow.h
    motif.h
    rtsyn.h
    server_defs.h
    soundspec.h
    vt100.h
    VTparse.h
    w32g_utl.h
    xaw.h
    xskin.h
    x_mag.h
    x_sherry.h
    x_wrdwindow.h
)

set(
    INTERFACE_W32G_COMMON_SOURCES

    w32g_c.c
    w32g_dib.c
    w32g_i.c
    w32g_ini.c
    w32g_int_synth_editor.c
    w32g_mag.c
    w32g_playlist.c
    w32g_pref.c
    w32g_subwin.c
    w32g_subwin2.c
    w32g_subwin3.c
    w32g_ut2.c
    w32g_utl.c
    w32g_soundspec.c
    wrdt_w32g.c

    soundspec.h
    w32g.h
    w32g_dib.h
    w32g_int_synth_editor.h
    w32g_mag.h
    w32g_pref.h
    w32g_rec.h
    w32g_res.h
    w32g_subwin.h
    w32g_tracer.h
    w32g_ut2.h
    w32g_utl.h
    w32g_wrd.h
)

if(MSVC)
    set_source_files_properties(
        w32g_res.rc

        PROPERTIES
            OBJECT_DEPENDS
                w32g_btn.bmp
                w32g_icon.ico
                w32g_icon_gray.ico
                w32g_icon_normal.ico
                w32g_icon_silver.ico
                w32g_playlist_play.ico
                w32g_sleep.bmp
                w32g_subbtn.bmp
                w32g_tracer.bmp
    )
endif()

# for timidity

add_library(
    interface OBJECT

    ${INTERFACE_COMMON_SOURCES}
    dumb_c.c
    wrdt_wcon.c
)

target_compile_definitions(interface PRIVATE -DIA_NCURSES)

# for twsynsrv

add_library(
    interface_synsrv OBJECT

    ${INTERFACE_COMMON_SOURCES}
    dumb_c.c
    rtsyn_winmm.c
    winsyn_c.c
    wrdt_wcon.c

	../twsyn_bridge/twsyn_bridge_host.c
	../twsyn_bridge/twsyn_bridge_host.h
)

add_dependencies(interface_synsrv twsyn_bridge)
target_compile_definitions(interface_synsrv PRIVATE -DIA_WINSYN -DTWSYNSRV)

# for timw32g

add_library(
    interface_w32g OBJECT

    ${INTERFACE_W32G_COMMON_SOURCES}
    w32g_res.rc
)

add_dependencies(interface_w32g UpdateTim41Version)
target_compile_definitions(interface_w32g PRIVATE -DIA_W32GUI -D__W32G__)

# for twsyng

add_library(
    interface_w32gsyn OBJECT

    ${INTERFACE_COMMON_SOURCES}
    ${INTERFACE_W32G_COMMON_SOURCES}
    rtsyn_winmm.c
    w32g_syn.c
    winsyn_c.c
    w32g_res.rc

	../twsyn_bridge/twsyn_bridge_host.c
	../twsyn_bridge/twsyn_bridge_host.h
)

add_dependencies(interface_w32gsyn UpdateTim41Version twsyn_bridge)
target_compile_definitions(interface_w32gsyn PRIVATE -DIA_W32G_SYN -D__W32G__ -DTWSYNG32)

=== lame/CMakeLists.txt ===

add_definitions(
    -DHAVE_CONFIG_H
    -DLAME_LIBRARY_BUILD
    -DHAVE_XMMINTRIN_H
    -DSTDC_HEADERS
    -DHAVE_ERRNO_H
    -DHAVE_FCNTL_H
    -DHAVE_LIMITS_H
    -DPACKAGE="lame"
    -DPROTOTYPES
    -DUSE_FAST_LOG
    -DHAVE_STRCHR
    -DHAVE_MEMCPY
)

include_directories(.)

add_library(
    lame_enc SHARED

    config.h

    Dll/BladeMP3EncDLL.c
    Dll/BladeMP3EncDLL.h

    include/lame.h

    libmp3lame/bitstream.c
    libmp3lame/bitstream.h
    libmp3lame/encoder.c
    libmp3lame/encoder.h
    libmp3lame/fft.c
    libmp3lame/fft.h
    libmp3lame/gain_analysis.c
    libmp3lame/gain_analysis.h
    libmp3lame/id3tag.c
    libmp3lame/id3tag.h
    libmp3lame/l3side.h
    libmp3lame/lame-analysis.h
    libmp3lame/lame.c
    libmp3lame/lameerror.h
    libmp3lame/lame_global_flags.h
    libmp3lame/machine.h
    libmp3lame/mpglib_interface.c
    libmp3lame/newmdct.c
    libmp3lame/newmdct.h
    libmp3lame/presets.c
    libmp3lame/psymodel.c
    libmp3lame/psymodel.h
    libmp3lame/quantize.c
    libmp3lame/quantize.h
    libmp3lame/quantize_pvt.c
    libmp3lame/quantize_pvt.h
    libmp3lame/reservoir.c
    libmp3lame/reservoir.h
    libmp3lame/set_get.c
    libmp3lame/set_get.h
    libmp3lame/tables.c
    libmp3lame/tables.h
    libmp3lame/takehiro.c
    libmp3lame/util.c
    libmp3lame/util.h
    libmp3lame/vbrquantize.c
    libmp3lame/vbrquantize.h
    libmp3lame/VbrTag.c
    libmp3lame/VbrTag.h
    libmp3lame/version.c
    libmp3lame/version.h
    libmp3lame/vector/lame_intrin.h
    libmp3lame/vector/xmm_quantize_sub.c

    Dll/BladeMP3EncDLL.def
    libmp3lame/lame.rc
)

set_target_properties(lame_enc PROPERTIES PREFIX "")

=== ogg/CMakeLists.txt ===

add_library(
    libogg SHARED

    include/ogg/ogg.h
    include/ogg/os_types.h

    src/bitwise.c
    src/framing.c

    win32/ogg.def
)

set_target_properties(libogg PROPERTIES PREFIX "")

=== opus/CMakeLists.txt ===

include_directories(
    "."
    celt
    include/opus
    silk
    silk/float
)

add_definitions(
    -DUSE_ALLOCA
    -DOPUS_BUILD
    -DFLOAT_APPROX
    -DDLL_EXPORT
    -DOPUS_X86_MAY_HAVE_SSE
    -DOPUS_X86_MAY_HAVE_SSE2
    -DOPUS_X86_MAY_HAVE_SSE4_1
    -DOPUS_X86_PRESUME_SSE
    -DOPUS_X86_PRESUME_SSE2
    -DOPUS_X86_PRESUME_SSE4_1
)

add_library(
    libopus SHARED

    include/opus/opus.h
    include/opus/opus_custom.h
    include/opus/opus_defines.h
    include/opus/opus_multistream.h
    include/opus/opus_types.h

    src/analysis.c
    src/analysis.h
    src/mlp.c
    src/mlp.h
    src/mlp_data.c
    src/opus.c
    src/opus_decoder.c
    src/opus_encoder.c
    src/opus_multistream.c
    src/opus_multistream_decoder.c
    src/opus_multistream_encoder.c
    src/opus_private.h
    src/repacketizer.c
    src/tansig_table.h

    celt/arch.h
    celt/bands.c
    celt/bands.h
    celt/celt.c
    celt/celt.h
    celt/celt_decoder.c
    celt/celt_encoder.c
    celt/celt_lpc.c
    celt/celt_lpc.h
    celt/cpu_support.h
    celt/cwrs.c
    celt/cwrs.h
    celt/ecintrin.h
    celt/entcode.c
    celt/entcode.h
    celt/entdec.c
    celt/entdec.h
    celt/entenc.c
    celt/entenc.h
    celt/fixed_debug.h
    celt/fixed_generic.h
    celt/float_cast.h
    celt/kiss_fft.c
    celt/kiss_fft.h
    celt/laplace.c
    celt/laplace.h
    celt/mathops.c
    celt/mathops.h
    celt/mdct.c
    celt/mdct.h
    celt/mfrngcod.h
    celt/modes.c
    celt/modes.h
    celt/os_support.h
    celt/pitch.c
    celt/pitch.h
    celt/quant_bands.c
    celt/quant_bands.h
    celt/rate.c
    celt/rate.h
    celt/stack_alloc.h
    celt/static_modes_fixed.h
    celt/static_modes_fixed_arm_ne10.h
    celt/static_modes_float.h
    celt/static_modes_float_arm_ne10.h
    celt/vq.c
    celt/vq.h
    celt/_kiss_fft_guts.h
    celt/x86/celt_lpc_sse.c
    celt/x86/celt_lpc_sse.h
    celt/x86/pitch_sse.c
    celt/x86/pitch_sse.h
    celt/x86/pitch_sse2.c
    celt/x86/pitch_sse4_1.c
    celt/x86/vq_sse.h
    celt/x86/vq_sse2.c
    celt/x86/x86cpu.c
    celt/x86/x86cpu.h
    celt/x86/x86_celt_map.c

    silk/A2NLSF.c
    silk/ana_filt_bank_1.c
    silk/API.h
    silk/biquad_alt.c
    silk/bwexpander.c
    silk/bwexpander_32.c
    silk/check_control_input.c
    silk/CNG.c
    silk/code_signs.c
    silk/control.h
    silk/control_audio_bandwidth.c
    silk/control_codec.c
    silk/control_SNR.c
    silk/debug.c
    silk/debug.h
    silk/decoder_set_fs.c
    silk/decode_core.c
    silk/decode_frame.c
    silk/decode_indices.c
    silk/decode_parameters.c
    silk/decode_pitch.c
    silk/decode_pulses.c
    silk/dec_API.c
    silk/define.h
    silk/encode_indices.c
    silk/encode_pulses.c
    silk/enc_API.c
    silk/errors.h
    silk/gain_quant.c
    silk/HP_variable_cutoff.c
    silk/init_decoder.c
    silk/init_encoder.c
    silk/Inlines.h
    silk/inner_prod_aligned.c
    silk/interpolate.c
    silk/lin2log.c
    silk/log2lin.c
    silk/LPC_analysis_filter.c
    silk/LPC_fit.c
    silk/LPC_inv_pred_gain.c
    silk/LP_variable_cutoff.c
    silk/MacroCount.h
    silk/MacroDebug.h
    silk/macros.h
    silk/main.h
    silk/NLSF2A.c
    silk/NLSF_decode.c
    silk/NLSF_del_dec_quant.c
    silk/NLSF_encode.c
    silk/NLSF_stabilize.c
    silk/NLSF_unpack.c
    silk/NLSF_VQ.c
    silk/NLSF_VQ_weights_laroia.c
    silk/NSQ.c
    silk/NSQ.h
    silk/NSQ_del_dec.c
    silk/pitch_est_defines.h
    silk/pitch_est_tables.c
    silk/PLC.c
    silk/PLC.h
    silk/process_NLSFs.c
    silk/quant_LTP_gains.c
    silk/resampler.c
    silk/resampler_down2.c
    silk/resampler_down2_3.c
    silk/resampler_private.h
    silk/resampler_private_AR2.c
    silk/resampler_private_down_FIR.c
    silk/resampler_private_IIR_FIR.c
    silk/resampler_private_up2_HQ.c
    silk/resampler_rom.c
    silk/resampler_rom.h
    silk/resampler_structs.h
    silk/shell_coder.c
    silk/sigm_Q15.c
    silk/SigProc_FIX.h
    silk/sort.c
    silk/stereo_decode_pred.c
    silk/stereo_encode_pred.c
    silk/stereo_find_predictor.c
    silk/stereo_LR_to_MS.c
    silk/stereo_MS_to_LR.c
    silk/stereo_quant_pred.c
    silk/structs.h
    silk/sum_sqr_shift.c
    silk/tables.h
    silk/tables_gain.c
    silk/tables_LTP.c
    silk/tables_NLSF_CB_NB_MB.c
    silk/tables_NLSF_CB_WB.c
    silk/tables_other.c
    silk/tables_pitch_lag.c
    silk/tables_pulses_per_block.c
    silk/table_LSF_cos.c
    silk/tuning_parameters.h
    silk/typedef.h
    silk/VAD.c
    silk/VQ_WMat_EC.c
    silk/float/apply_sine_window_FLP.c
    silk/float/autocorrelation_FLP.c
    silk/float/burg_modified_FLP.c
    silk/float/bwexpander_FLP.c
    silk/float/corrMatrix_FLP.c
    silk/float/encode_frame_FLP.c
    silk/float/energy_FLP.c
    silk/float/find_LPC_FLP.c
    silk/float/find_LTP_FLP.c
    silk/float/find_pitch_lags_FLP.c
    silk/float/find_pred_coefs_FLP.c
    silk/float/inner_product_FLP.c
    silk/float/k2a_FLP.c
    silk/float/LPC_analysis_filter_FLP.c
    silk/float/LPC_inv_pred_gain_FLP.c
    silk/float/LTP_analysis_filter_FLP.c
    silk/float/LTP_scale_ctrl_FLP.c
    silk/float/main_FLP.h
    silk/float/noise_shape_analysis_FLP.c
    silk/float/pitch_analysis_core_FLP.c
    silk/float/process_gains_FLP.c
    silk/float/regularize_correlations_FLP.c
    silk/float/residual_energy_FLP.c
    silk/float/scale_copy_vector_FLP.c
    silk/float/scale_vector_FLP.c
    silk/float/schur_FLP.c
    silk/float/SigProc_FLP.h
    silk/float/sort_FLP.c
    silk/float/structs_FLP.h
    silk/float/warped_autocorrelation_FLP.c
    silk/float/wrappers_FLP.c
    silk/x86/main_sse.h
    silk/x86/NSQ_del_dec_sse.c
    silk/x86/NSQ_sse.c
    silk/x86/SigProc_FIX_sse.h
    silk/x86/VAD_sse.c
    silk/x86/VQ_WMat_EC_sse.c
    silk/x86/x86_silk_map.c
)

set_target_properties(libopus PROPERTIES PREFIX "")

=== pdcurses/CMakeLists.txt ===

add_library(
    pdcurses SHARED

    pdcurses/addch.c
    pdcurses/addchstr.c
    pdcurses/addstr.c
    pdcurses/attr.c
    pdcurses/beep.c
    pdcurses/bkgd.c
    pdcurses/border.c
    pdcurses/clear.c
    pdcurses/color.c
    pdcurses/debug.c
    pdcurses/delch.c
    pdcurses/deleteln.c
    pdcurses/deprec.c
    pdcurses/getch.c
    pdcurses/getstr.c
    pdcurses/getyx.c
    pdcurses/inch.c
    pdcurses/inchstr.c
    pdcurses/initscr.c
    pdcurses/inopts.c
    pdcurses/insch.c
    pdcurses/insstr.c
    pdcurses/instr.c
    pdcurses/kernel.c
    pdcurses/keyname.c
    pdcurses/mouse.c
    pdcurses/move.c
    pdcurses/outopts.c
    pdcurses/overlay.c
    pdcurses/pad.c
    pdcurses/panel.c
    win32/pdcclip.c
    win32/pdcdisp.c
    win32/pdcgetsc.c
    win32/pdckbd.c
    win32/pdcscrn.c
    win32/pdcsetsc.c
    win32/pdcutil.c
    pdcurses/printw.c
    pdcurses/refresh.c
    pdcurses/scanw.c
    pdcurses/scr_dump.c
    pdcurses/scroll.c
    pdcurses/slk.c
    pdcurses/termattr.c
    pdcurses/terminfo.c
    pdcurses/touch.c
    pdcurses/util.c
    pdcurses/window.c

    curses.h
    curspriv.h
    panel.h
    win32/pdcwin.h
    term.h

    pdcurses.def
    win32/pdcurses.rc
)

=== sf_view_gui/CMakeLists.txt ===

add_definitions(
    -DCFG_FOR_SF
    -DSF2VIEWER_GUI
)

add_executable(
    sfviewer WIN32

    mysndfont.c
    OpenDlg.cpp
    sfview_main.cpp
    ../interface/dumb_c.c
    ../timidity/common.c
    ../timidity/controls.c
    ../timidity/envelope.c
    ../timidity/filter.c
    ../timidity/freq.c
    ../timidity/instrum.c
    ../timidity/int_synth.c
    ../timidity/mt19937ar.c
    ../timidity/myini.c
    ../timidity/quantity.c
    ../timidity/resample.c
    ../timidity/sbkconv.c
    ../timidity/sffile.c
    ../timidity/sfitem.c
    ../timidity/sfz.cpp
    ../timidity/smplfile.c
    ../timidity/tables.c
    ../timidity/version.c

    OpenDlg.h
    resource.h
    ../libarc/arc.h
    ../timidity/common.h
    ../timidity/controls.h
    ../timidity/envelope.h
    ../timidity/filter.h
    ../timidity/instrum.h
    ../timidity/int_synth.h
    ../timidity/mt19937ar.h
    ../timidity/myini.h
    ../timidity/output.h
    ../timidity/playmidi.h
    ../timidity/quantity.h
    ../timidity/readmidi.h
    ../timidity/resample.h
    ../timidity/sffile.h
    ../timidity/sfitem.h
    ../timidity/sflayer.h
    ../timidity/sfz.h
    ../timidity/tables.h
    ../timidity/timidity.h
    ../timidity/wrd.h
    ../utils/mblock.h
    ../utils/support.h

    sfview_dlg.rc

    $<TARGET_OBJECTS:libarc>
    $<TARGET_OBJECTS:utils>
)

add_dependencies(sfviewer UpdateTim41Version)
target_link_libraries(sfviewer comctl32 shlwapi winmm ws2_32)

=== speex/CMakeLists.txt ===

add_definitions(
    -DHAVE_CONFIG_H
    -DFIXED_POINT
)

add_library(
    speex SHARED

    bits.c
    cb_search.c
    exc_10_16_table.c
    exc_10_32_table.c
    exc_20_32_table.c
    exc_5_256_table.c
    exc_5_64_table.c
    exc_8_128_table.c
    filters.c
    gain_table.c
    gain_table_lbr.c
    hexc_10_32_table.c
    hexc_table.c
    high_lsp_tables.c
    lpc.c
    lsp.c
    lsp_tables_nb.c
    ltp.c
    modes.c
    modes_wb.c
    nb_celp.c
    quant_lsp.c
    sb_celp.c
    speex.c
    speex_callbacks.c
    speex_header.c
    stereo.c
    vbr.c
    vq.c
    window.c
    
    config.h
    arch.h
    cb_search.h
    cb_search_sse.h
    filters.h
    filters_sse.h
    fixed_debug.h
    fixed_generic.h
    lpc.h
    lsp.h
    ltp.h
    ltp_sse.h
    math_approx.h
    modes.h
    nb_celp.h
    os_support.h
    quant_lsp.h
    sb_celp.h
    stack_alloc.h
    vbr.h
    vq.h
    vq_sse.h
    speex.h
    speex_bits.h
    speex_callbacks.h
    speex_header.h
    speex_stereo.h
    speex_types.h

    libspeex.def
)

=== timidity/CMakeLists.txt ===

add_definitions(
    [[-DDEFAULT_PATH=".\\"]]
)

# calcnewton

add_executable(calcnewton calcnewt.c)
add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/newton_table.c"
    COMMAND calcnewton "${CMAKE_CURRENT_BINARY_DIR}/newton_table.c"
)

set_source_files_properties(resample.c OBJECT_DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/newton_table.c")
include_directories("${CMAKE_CURRENT_BINARY_DIR}")

# timidity common

set(
    TIMIDITY_COMMON_SOURCES

    aiff_a.c
    ao_a.c
    aq.c
    au_a.c
    audio_cnv.c
    common.c
    controls.c
    effect.c
    envelope.c
    filter.c
    flac_a.c
    freq.c
    gogo_a.c
    instrum.c
    int_synth.c
    lame_a.c
    midi_a.c
    oscillator.c
    list_a.c
    loadtab.c
    m2m.c
    mfi.c
    mfnode.c
    miditrace.c
    mix.c
    mod.c
    mod2midi.c
    modmid_a.c
    mt19937ar.c
    myini.c
    npipe_a.c
    optcode.c
    opus_a.c
    output.c
    playmidi.c
    portaudio_a.c
    quantity.c
    raw_a.c
    rcp.c
    readmidi.c
    recache.c
    resample.c
    sbkconv.c
    sffile.c
    sfitem.c
    sfz.cpp
    benchmark_a.c
    smfconv.c
    smplfile.c
    sndfont.c
    sndfontini.c
    speex_a.c
    tables.c
    thread.c
    timer2.c
    timidity.c
    version.c
    voice_effect.c
    volumecalc_a.c
    vorbis_a.c
    w32_a.c
    w32_gogo.c
    wasapi_a.c
    wave_a.c
    w32g_ogg_dll.c
    w32_portaudio_dll.c
    w32g_vorbis_dll.c
    w32g_vorbisenc_dll.c
    w32g_opus_dll.c
    w32_libFLAC_dll.c
    w32_libOggFLAC_dll.c
    wdmks_a.c
    wrd_read.c
    wrdt.c
    
    aenc.h
    aq.h
    audio_cnv.h
    audriv.h
    common.h
    controls.h
    dlutils.h
    filter.h
    freq.h
    gogo_a.h
    instrum.h
    int_synth.h
    LameEnc.h
    oscillator.h
    loadsndfontini.h
    mac_com.h
    mac_main.h
    mfnode.h
    miditrace.h
    mix.h
    mod.h
    mod2midi.h
    mt19937ar.h
    myini.h
    optcode.h
    output.h
    playmidi.h
    portaudio_a.h
    pragmapack.h
    quantity.h
    readmidi.h
    recache.h
    resample.h
    effect.h
    sffile.h
    sfitem.h
    sflayer.h
    sfz.h
    smfconv.h
    sndfontini.h
    sysdep.h
    tables.h
    thread.h
    timer2.h
    timidity.h
    voice_effect.h
    vstwrapper.h
    w32_a.h
    w32_gogo.h
    w32_libFLAC_dll.h
    w32_libFLAC_dll_g.h
    w32_libFLAC_dll_i.h
    w32_libOggFLAC_dll.h
    w32_libOggFLAC_dll_g.h
    w32_libOggFLAC_dll_i.h
	wasapi_a.h
    wdmks_a.h
    wrd.h

    $<TARGET_OBJECTS:libarc>
    $<TARGET_OBJECTS:libunimod>
    $<TARGET_OBJECTS:utils>
)

set(
    TIMIDITY_COMMON_LIBS

    speex

    avrt
    comctl32
    setupapi
    shlwapi
    winmm
    ws2_32
)

# timidity

add_executable(
    timidity

    ${TIMIDITY_COMMON_SOURCES}
    $<TARGET_OBJECTS:interface>
)

add_dependencies(timidity UpdateTim41Version)
target_compile_definitions(timidity PRIVATE -DIA_NCURSES)
target_link_libraries(timidity ${TIMIDITY_COMMON_LIBS} pdcurses)

# twsynsrv

add_executable(
    twsynsrv

    ${TIMIDITY_COMMON_SOURCES}
    $<TARGET_OBJECTS:interface_synsrv>
)

add_dependencies(twsynsrv UpdateTim41Version)
target_compile_definitions(twsynsrv PRIVATE -DIA_WINSYN -DTWSYNSRV)
target_link_libraries(twsynsrv ${TIMIDITY_COMMON_LIBS} pdcurses)

# timw32g

add_executable(
    timw32g WIN32

    ${TIMIDITY_COMMON_SOURCES}
    $<TARGET_OBJECTS:interface_w32g>
)

add_dependencies(timw32g UpdateTim41Version)
target_compile_definitions(timw32g PRIVATE -DIA_W32GUI -D__W32G__)
target_link_libraries(timw32g ${TIMIDITY_COMMON_LIBS})
DisableMSManifest(timw32g)

# twsyng

add_executable(
    twsyng WIN32

    ${TIMIDITY_COMMON_SOURCES}
    $<TARGET_OBJECTS:interface_w32gsyn>
)

add_dependencies(twsyng UpdateTim41Version)
target_compile_definitions(twsyng PRIVATE -DIA_W32G_SYN -D__W32G__ -DTWSYNG32)
target_link_libraries(twsyng ${TIMIDITY_COMMON_LIBS} pdcurses)
DisableMSManifest(twsyng)

=== vorbis/CMakeLists.txt ===

include_directories(lib)

add_library(
    libvorbis SHARED

    include/vorbis/codec.h
    include/vorbis/vorbisenc.h
    include/vorbis/vorbisfile.h

    lib/analysis.c
    lib/backends.h
    lib/barkmel.c
    lib/bitrate.c
    lib/bitrate.h
    lib/block.c
    lib/codebook.c
    lib/codebook.h
    lib/codec_internal.h
    lib/envelope.c
    lib/envelope.h
    lib/floor0.c
    lib/floor1.c
    lib/highlevel.h
    lib/info.c
    lib/lookup.c
    lib/lookup.h
    lib/lookups.pl
    lib/lookup_data.h
    lib/lpc.c
    lib/lpc.h
    lib/lsp.c
    lib/lsp.h
    lib/mapping0.c
    lib/masking.h
    lib/mdct.c
    lib/mdct.h
    lib/misc.h
    lib/os.h
    lib/psy.c
    lib/psy.h
    lib/registry.c
    lib/registry.h
    lib/res0.c
    lib/scales.h
    lib/sharedbook.c
    lib/smallft.c
    lib/smallft.h
    lib/synthesis.c
    lib/vorbisenc.c
    lib/vorbisfile.c
    lib/window.c
    lib/window.h
    lib/books/coupled/res_books_51.h
    lib/books/coupled/res_books_stereo.h
    lib/books/floor/floor_books.h
    lib/books/uncoupled/res_books_uncoupled.h
    lib/modes/floor_all.h
    lib/modes/psych_11.h
    lib/modes/psych_16.h
    lib/modes/psych_44.h
    lib/modes/psych_8.h
    lib/modes/residue_16.h
    lib/modes/residue_44.h
    lib/modes/residue_44p51.h
    lib/modes/residue_44u.h
    lib/modes/residue_8.h
    lib/modes/setup_11.h
    lib/modes/setup_16.h
    lib/modes/setup_22.h
    lib/modes/setup_32.h
    lib/modes/setup_44.h
    lib/modes/setup_44p51.h
    lib/modes/setup_44u.h
    lib/modes/setup_8.h
    lib/modes/setup_X.h

    win32/vorbis.def
    win32/vorbisenc.def
    win32/vorbisfile.def
)

set_target_properties(libvorbis PROPERTIES PREFIX "")
target_link_libraries(libvorbis libogg)

=== debian/changelog ===
timidity (2.14.0-1) unstable; urgency=low

  * NEWS: Add new entry for 2.14.0
  * configure.in: Change version to 2.14.0

 -- TAMUKI Shoichi <tamuki@linet.gr.jp>  Thu, 26 Jun 2012 00:00:00 +0900

timidity (2.13.2-39) unstable; urgency=low

  * Orphan the package.

 -- Joost Yervante Damad <andete@debian.org>  Tue, 08 Jun 2010 18:33:18 +0200

timidity (2.13.2-38) unstable; urgency=low

  * Close stdin and stderr (Closes: #581914)
  * not all individual upgrades work out fine, normally the
    ones involving released versions should (Closes: #538967)
  * be less quiet about failure to stop (Closes: #563251)

 -- Joost Yervante Damad <andete@debian.org>  Fri, 21 May 2010 10:50:43 +0200

timidity (2.13.2-37) unstable; urgency=low

  * update source format to 3.0
  * update standards version to 3.8.3
  * rebuild to make sure proper esd lib is used
  * user was using old config file (Closes: #545492)
  * sometimes other applications block the sound card (Closes: #440852, #557638)
    (see also https://bugs.launchpad.net/ubuntu/+source/timidity/+bug/120810 )

 -- Joost Yervante Damad <andete@debian.org>  Wed, 30 Dec 2009 16:32:31 +0100

timidity (2.13.2-36) unstable; urgency=low

  * Make sure stop is only invoked when init.d script actually
    exists (Closes: #546815)

 -- Joost Yervante Damad <andete@debian.org>  Wed, 16 Sep 2009 13:53:56 +0200

timidity (2.13.2-35) unstable; urgency=low

  * apply fedora_forkfix with thanks to Alban Browaeys for
    pointing out the patch and Paul Menzel for doing initial
   testing. (Closes: #544061) (Closes: #545476)
  * lots of upgrade testing, this version should survive
    an upgrade from a pre-timidity-daemon version unharmed
    (Closes: #538967)

 -- Joost Yervante Damad <andete@debian.org>  Fri, 11 Sep 2009 09:16:27 +0200

timidity (2.13.2-34) unstable; urgency=low

  * also remove config file from timidity if it is still
    owned by timidity (which hopefully fixes the problem
    also for the reporter...) (Closes: #538967)

 -- Joost Yervante Damad <andete@debian.org>  Mon, 07 Sep 2009 07:53:02 +0200

timidity (2.13.2-33) unstable; urgency=low

  * remove /etc/init.d/timidity on removal
    of timidity-daemon (Closes: #538967)
  * don't Depend on freepats a Recommends is good enough
    as it will still be installed by default for basic users
    (Closes: #542937)
  * use Recommends for timidity-daemon to allow smoother
    upgrade for basic users

 -- Joost Yervante Damad <andete@debian.org>  Mon, 24 Aug 2009 19:37:30 +0200

timidity (2.13.2-32) unstable; urgency=low

  * fix installation of /etc/default/timidity
    (although it was done as documented in man dh_installinit
     with the --name option method)

 -- Joost Yervante Damad <andete@debian.org>  Thu, 23 Jul 2009 06:58:11 +0200

timidity (2.13.2-31) unstable; urgency=low

  * relocate /etc/init.d/timidity to timidity-daemon
  * don't depend on existance of file in /usr/share/doc/*
    (Closes: #537830)
  * fix typo in timidity-daemon.postinst

 -- Joost Yervante Damad <andete@debian.org>  Tue, 21 Jul 2009 16:11:26 +0200

timidity (2.13.2-30) unstable; urgency=low

  * don't chown in postinst anymore (Closes: #537812)

 -- Joost Yervante Damad <andete@debian.org>  Tue, 21 Jul 2009 09:55:03 +0200

timidity (2.13.2-29) unstable; urgency=low

  * don't make /var/run/timidity part of the package
    as /var/run could be a temp filesystem, instead make
    the dir in the init script

 -- Joost Yervante Damad <andete@debian.org>  Sat, 18 Jul 2009 14:13:39 +0200

timidity (2.13.2-28) unstable; urgency=low

  * make sure timidity.deamon is removed not just on purge
    but also on remove
    check for existance of /var/run/timidity instead (which
    is now also used to make the pid file)
  * fix pid handling (pid files are icky)

 -- Joost Yervante Damad <andete@debian.org>  Sat, 18 Jul 2009 13:07:03 +0200

timidity (2.13.2-27) unstable; urgency=low

  * introduce timidity-deamon to ease the choice of the
    user and/or other packages to want a system-wide
    timidity alsa sequencer daemon (Closes: #531080)
  * update standards version to 3.8.2
  * debhelper compat level 7

 -- Joost Yervante Damad <andete@debian.org>  Fri, 17 Jul 2009 08:47:58 +0200

timidity (2.13.2-26) unstable; urgency=low

  * (hopefully) fix drum panning with thanks to Steve Graham
    for providing a fix (Closes: #536252)

 -- Joost Yervante Damad <andete@debian.org>  Fri, 17 Jul 2009 08:10:30 +0200

timidity (2.13.2-25) unstable; urgency=low

  * fix -q-q typo in debian/rules (Closes: #530957)

 -- Joost Yervante Damad <andete@debian.org>  Fri, 29 May 2009 07:57:52 +0200

timidity (2.13.2-24) unstable; urgency=low

  * stop depending on ARTS (closes: #528182)

 -- Joost Yervante Damad <andete@debian.org>  Tue, 12 May 2009 19:45:41 +0200

timidity (2.13.2-23) unstable; urgency=low

  * build depend on libjack-dev isof libjack0... (closes: #527435)
  * fix timidity-el section => lisp
  * fix debian/timidity-interfaces-extra.desktop binary path
  * add status method to init.d script (closes: #527884)
    with thanks to Peter Eisentraut for providing a patch
  * be a little more clear in the init.d message when it is not enabled
    although it's rather verbose :( (closes: #460588)

 -- Joost Yervante Damad <andete@debian.org>  Mon, 23 Mar 2009 19:42:09 +0100

timidity (2.13.2-22) unstable; urgency=low

  * do not build with -Werror; some archs use different
    compilers

 -- Joost Yervante Damad <andete@debian.org>  Wed, 18 Feb 2009 18:17:00 +0100

timidity (2.13.2-21) unstable; urgency=low

  * Document how to enable the ALSA sequencer interface in
    README.Debian (Closes: #493224)
  * merge changes from ubuntu:
    - install Japanese docs
    - debian/timidity-interfaces-extra.desktop
    - debian/timidity.postinst
    - debian/timidity.preinst
    - debian/timidity.prerm
    - debian/TiMidity-uj_UTF8.ad
  * stricter compilation with EXTRAFLAGS
    - lots of tiny compile fixes
  * lintian fixes


=== debian/control ===
Source: timidity
Section: sound
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper (>= 7), libasound2-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386], libaudiofile-dev, libesd0-dev, libjack-dev, libaudio-dev, libportaudio-dev (>= 18.0), libportmidi-dev, libvorbis-dev (>= 1.0.0-3), libspeex-dev (>= 1.0), libflac-dev (>= 1.1.4), libncurses-dev, libslang2-dev, libx11-dev, libxext-dev, libxmu-dev, libxpm-dev, libxt-dev, libxaw7-dev, tcl8.4-dev, tk8.4-dev, libgtk2.0-dev, autotools-dev
Standards-Version: 3.8.3
Homepage: http://timidity.sourceforge.net/

Package: timidity
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base (>= 3.2-13)
Recommends: freepats, timidity-daemon
Suggests: pmidi, fluid-soundfont-gm, fluid-soundfont-gs
Description: Software sound renderer (MIDI sequencer, MOD player)
 TiMidity++ is a very high quality software-only MIDI sequencer and MOD player.
 It uses sound fonts (GUS-compatible or SF2-compatible) to render MIDI files,
 which are not included in this package.
 .
   * Plays MIDI files without any external MIDI instruments at all
   * Understands SMF, RCP/R36/G18/G36, MFI, RMI (MIDI)
   * Autodetects and supports GM/GS/XG MIDI
   * Understands MOD, XM, S3M, IT, 699, AMF, DSM, FAR, GDM,
     IMF, MED, MTM, STM, STX, ULT, UNI (MOD)
   * Does MOD to MIDI conversion (including playback)
   * Outputs audio into various audio file formats: WAV, au, AIFF,
     Ogg (Vorbis, FLAC, Speex)
   * Supports NAS, eSound, JACK, ALSA and OSS drivers
   * Uses Gravis Ultrasound compatible patch files and SoundFont2 patch
     files as the voice data for MIDI instruments
   * Supports playing from archives (zip, lzh, tar...) and playing remote
     data from the network
   * Timidity++ can be used as an ALSA sequencer device

Package: timidity-interfaces-extra
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, timidity (= ${binary:Version})
Replaces: timidity (<< 2.12.0)
Description: TiMidity++ extra user interfaces
 TiMidity++ is a very high quality software-only MIDI sequencer and MOD 
 player.
 .
 This package provides extra TiMidity++ user interfaces, which have
 limited functionality when compared to those in the main package.
 .
 Interfaces in this package: VT100, Tcl/Tk, S-Lang, XSkin, GTK2

Package: timidity-el
Section: lisp
Architecture: all
Depends: emacsen-common, ${misc:Depends}, timidity (>= ${source:Version})
Description: An Emacs front end to Timidity++
 The timidity.el Emacs-Lisp program is a front-end to the TiMidity++ software-
 only MIDI sequencer and MOD player.  You can play MIDI amd MOD files directly
 from Emacs with this package.

Package: timidity-daemon
Section: sound
Architecture: all
Depends: ${misc:Depends}, timidity (>= ${source:Version}), adduser
Replaces: timidity (<< 2.13.2-31)
Description: runs TiMidity++ as a system-wide MIDI sequencer
 TiMidity++ is a very high quality software-only MIDI sequencer and MOD 
 player.
 .
 This package provides TiMidity++ as a system-wide MIDI sequencer.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for TiMidity++ 2.12.x
#
# GNU copyright 1997 by Joey Hess.
# Copyright (c) 2003 by Henrique de Moraes Holschuh
# Published under the GNU GPL license
# Based on previous work by Martin Mitchell <martin@debian.org>
#
# $Id: rules,v 1.24 2004/10/01 15:18:25 hmh Exp $

export TMPPKG := $(CURDIR)/debian/tmp

# Autotools
export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
export DEB_BUILD_ARCH_OS ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)

# FOR AUTOCONF 2.52 AND NEWER ONLY
CONFFLAGS =
ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  CONFFLAGS += --build $(DEB_HOST_GNU_TYPE)
else
  CONFFLAGS += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

# DEB_BUILD_OPTIONS
DEBUGFLAGS=-g
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	DEBUGFLAGS += -O0
else
        DEBUGFLAGS += -O2
endif

EXTRAFLAGS:=-D_FORTIFY_SOURCE=2 -Wformat -Wformat-security

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CONFFLAGS += --enable-debug
endif

# audio and interface
ifeq ($(DEB_BUILD_ARCH_OS), linux)
audio = default,oss,nas,esd,jack,vorbis,flac,speex,portaudio,alsa
interface = ncurses,slang,motif,tcltk,emacs,vt100,xaw,xskin,gtk,portmidisyng,alsaseq
else
audio = default,oss,nas,esd,jack,vorbis,flac,speex,portaudio
interface = ncurses,slang,motif,tcltk,emacs,vt100,xaw,xskin,gtk,portmidisyng
endif

MAKE_CFLAGS:=$(EXTRAFLAGS) -fno-strict-aliasing -Wall -pipe $(DEBUGFLAGS)

##
##  The rules
##

build: doconfigure build-stamp
build-stamp:
	dh_testdir
	$(MAKE) CFLAGS="$(MAKE_CFLAGS)"
	touch build-stamp

doconfigure: doconfigure-stamp
doconfigure-stamp:
	dh_testdir
	rm -f autoconf/config.sub autoconf/config.guess
	ln -s /usr/share/misc/config.sub autoconf/config.sub
	ln -s /usr/share/misc/config.guess autoconf/config.guess

	CFLAGS="-fno-strict-aliasing -Wall -pipe $(DEBUGFLAGS)"
	sh ./autogen.sh $(CONFFLAGS) \
	 --prefix=/usr --mandir=/usr/share/man --infodir=/usr/share/info \
	 --sysconfdir=/etc --with-default-path=/etc/timidity \
	 --with-lispdir=/usr/share/emacs/site-lisp/timidity-el \
	 --with-x \
	 --with-tcl-includes=/usr/include/tcl8.4 \
	 --with-tk-includes=/usr/include/tcl8.4 \
	 --enable-audio=$(audio) \
	 --with-default-output=default \
	 --enable-interface=$(interface) \
	 --enable-dynamic=slang,tcltk,vt100,xskin,gtk \
	 --enable-server --enable-network --enable-spectrogram --enable-wrd \
	 --enable-xft --enable-xdnd --enable-offix --enable-thread --enable-largefile \
	 --enable-spline=gauss --enable-filter=no --enable-datatype=double
	touch doconfigure-stamp

clean:	configure doconfigure
	dh_testdir
	dh_testroot
	-find -type f -perm +111 ! -name 'rules' -exec chmod 644 {} \;
	-xargs -t -r chmod +x < debian/executable.files
	rm -f build-stamp
	$(MAKE) clean
	$(MAKE) distclean
	rm -f common.makefile TiMidity-uj.ad TiMidity.ad
	rm -f interface/tclIndex
	rm -f doc/timidity.1 doc/timidity.cfg.5
	rm -f autoconf/config.sub autoconf/config.guess
	rm -rf autom4te.cache
	rm -f config.log Makefile
	rm -f doconfigure-stamp
	dh_clean

configure:
	sh ./autogen.sh

install:
install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) DESTDIR=$(TMPPKG) install

	#XAW interface
	mkdir -p $(TMPPKG)/etc/X11/app-defaults
	install -m 644 interface/TiMidity.ad $(TMPPKG)/etc/X11/app-defaults/TiMidity
	mkdir -p $(TMPPKG)/etc/X11/ja_JP.eucJP/app-defaults
	install -m 644 interface/TiMidity-uj.ad $(TMPPKG)/etc/X11/ja_JP.eucJP/app-defaults/TiMidity
	mkdir -p $(TMPPKG)/etc/X11/ja_JP.UTF-8/app-defaults
	install -m 644 debian/TiMidity-uj_UTF8.ad $(TMPPKG)/etc/X11/ja_JP.UTF-8/app-defaults/TiMidity

	if [ -r debian/timidity.cfg ] ; then \
		mkdir -p $(TMPPKG)/etc/timidity && \
		install -m 644 debian/timidity.cfg $(TMPPKG)/etc/timidity ;\
	fi

	mkdir -p $(TMPPKG)/etc/default

	# install xbm/xpm file
	mkdir -p $(TMPPKG)/usr/lib/timidity/bitmaps
	install -m 644 interface/bitmaps/*.xbm $(TMPPKG)/usr/lib/timidity/bitmaps
	mkdir -p $(TMPPKG)/usr/lib/timidity/motif_bitmaps
	install -m 644 interface/motif_bitmaps/*.xbm $(TMPPKG)/usr/lib/timidity/motif_bitmaps
	mkdir -p $(TMPPKG)/usr/lib/timidity/pixmaps
	install -m 644 interface/pixmaps/*.xpm $(TMPPKG)/usr/lib/timidity/pixmaps

	# install desktop file
	mkdir -p $(TMPPKG)/usr/share/applications
	install -m 644 debian/timidity-interfaces-extra.desktop $(TMPPKG)/usr/share/applications

	# install an icon for menu
	mkdir -p $(TMPPKG)/usr/share/pixmaps
	install -m 644 debian/timidity.xpm $(TMPPKG)/usr/share/pixmaps

	# install Japanese man files
	mkdir -p $(TMPPKG)/usr/share/man/ja/man1
	install -m 644 doc/ja_JP.eucJP/timidity.1 $(TMPPKG)/usr/share/man/ja/man1
	mkdir -p $(TMPPKG)/usr/share/man/ja/man5
	install -m 644 doc/ja_JP.eucJP/timidity.cfg.5 $(TMPPKG)/usr/share/man/ja/man5

	# fix permissions
	chmod a+x  $(TMPPKG)/usr/lib/timidity/tk*.tcl

	# Lintian and Linda overrides
	( cd debian && \
	for i in *.linda ; do [ -r "$$i" ] && { \
		mkdir -p "$${i%%.linda}/usr/share/linda/overrides" ;\
		install  -m 644 "$$i" "$${i%%.linda}/usr/share/linda/overrides/$${i%%.linda}" ;\
	} ; done ; true )
	( cd debian && \
	for i in *.lintian ; do [ -r "$$i" ] && { \
		mkdir -p "$${i%%.lintian}/usr/share/lintian/overrides" ;\
		install  -m 644 "$$i" "$${i%%.lintian}/usr/share/lintian/overrides/$${i%%.lintian}" ;\
	} ; done ; true )

	#dh_installdebconf
	dh_installdocs
	dh_installexamples
	dh_installmenu
	dh_installemacsen
	dh_installman
	dh_installchangelogs
	dh_installinit -R --name=timidity -i -- defaults 99 01
	install -m 644 debian/timidity.default $(TMPPKG)/etc/default/timidity
	dh_install

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_link -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
#	dh_perl -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_strip -a
	dh_link -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
#	dh_makeshlibs -a
#	dh_perl -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
